﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Namespace TestClasses
    Public Class DayInfo
        Implements INotifyPropertyChanged


        Public Sub New()
            If DesignerProperties.GetIsInDesignMode(New DependencyObject) Then
                GreetingText = "Hallo, wie geht es dir zur Designtime?"
                CurrentDate = DateTime.Today()

                MeetingsToday = New ObservableCollection(Of Meeting) From {
                    New Meeting("Besprechung mit Franz", New Date(CurrentDate.Year, CurrentDate.Month, CurrentDate.Day, 9, 30, 0), TimeSpan.FromMinutes(60)),
                    New Meeting("Quartalsmetting", New Date(CurrentDate.Year, CurrentDate.Month, CurrentDate.Day, 13, 0, 0), TimeSpan.FromMinutes(90)),
                    New Meeting("Abendessen mit Chef", New Date(CurrentDate.Year, CurrentDate.Month, CurrentDate.Day, 16, 0, 0), TimeSpan.FromMinutes(15))
                    }

                TodayWeather = New WeatherInfo() With {.CurrentTemp = 23.5, .WindDirection = WindDirection.North, .Windspeed = 15}
            Else

                GreetingText = "Hallo, wie geht es dir an diesem schönen Tag?"
                CurrentDate = DateTime.Today()

                MeetingsToday = New ObservableCollection(Of Meeting) From {
                    New Meeting("Besprechung mit Franz", New Date(CurrentDate.Year, CurrentDate.Month, CurrentDate.Day, 9, 30, 0), TimeSpan.FromMinutes(60)),
                    New Meeting("Quartalsmetting", New Date(CurrentDate.Year, CurrentDate.Month, CurrentDate.Day, 13, 0, 0), TimeSpan.FromMinutes(90)),
                    New Meeting("Abendessen mit Chef", New Date(CurrentDate.Year, CurrentDate.Month, CurrentDate.Day, 16, 0, 0), TimeSpan.FromMinutes(15))
                    }

                TodayWeather = New WeatherInfo() With {.CurrentTemp = 23.5, .WindDirection = WindDirection.North, .Windspeed = 15}
            End If

        End Sub



        Private _greetingText As String
        Public Property GreetingText() As String
            Get
                Return _greetingText
            End Get
            Set(ByVal value As String)
                _greetingText = value
                RaisePropertyChanged()
            End Set
        End Property



        Private _currentDate As DateTime
        Public Property CurrentDate() As DateTime
            Get
                Return _currentDate
            End Get
            Set(ByVal value As DateTime)
                _currentDate = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _meetingsToday As ObservableCollection(Of Meeting)

        Public Property MeetingsToday() As ObservableCollection(Of Meeting)
            Get
                Return _meetingsToday
            End Get
            Set(ByVal value As ObservableCollection(Of Meeting))
                _meetingsToday = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _todayWeather As WeatherInfo

        Public Property TodayWeather() As WeatherInfo
            Get
                Return _todayWeather
            End Get
            Set(ByVal value As WeatherInfo)
                _todayWeather = value
                RaisePropertyChanged()
            End Set
        End Property



        Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
        End Sub

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    End Class
End Namespace