﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Namespace TestClasses
    Public Class WeatherInfo
        Implements INotifyPropertyChanged


        Private _windspeed As Integer

        Public Property Windspeed() As Integer
            Get
                Return _windspeed
            End Get
            Set(ByVal value As Integer)
                _windspeed = value
                RaisePropertyChanged()
            End Set
        End Property


        Private _windDirection As WindDirection

        Public Property WindDirection() As WindDirection
            Get
                Return _windDirection
            End Get
            Set(ByVal value As WindDirection)
                _windDirection = value
                RaisePropertyChanged()
                RaisePropertyChanged(NameOf(WindDirectionGerman))
            End Set
        End Property

        Public ReadOnly Property WindDirectionGerman As String
            Get
                Select Case WindDirection
                    Case WindDirection.North
                        Return "Norden"
                    Case WindDirection.East
                        Return "Osten"
                    Case WindDirection.South
                        Return "Süden"
                    Case WindDirection.West
                        Return "Westen"
                    Case Else
                        Return "unknown winddirection"
                End Select
            End Get
        End Property


        Private _currentTemp As Double

        Public Property CurrentTemp() As Double
            Get
                Return _currentTemp
            End Get
            Set(ByVal value As Double)
                _currentTemp = value
                RaisePropertyChanged()
            End Set
        End Property


        Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
        End Sub

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    End Class
End Namespace
